package com.adamatomic.Mode
{
	import adobe.utils.CustomActions;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.system.System;
	import flash.text.engine.BreakOpportunity;
	import org.flixel.*;

	public class MenuState extends FlxState
	{				
		private var _lastx:int;
		private var _lasty:int;
		private var _mx:int;		
		private var _my:int;
		private var _curvemode:Boolean;
		
		private var _downOnCanvas:Boolean;
		private function numToLetter(s:String):String
		{
			switch (s)
			{
				case "0":
				return "ZERO";
				break;
				case "1":
				return "ONE";
				break;
				case "2":
				return "TWO";
				break;
				case "3":
				return "THREE";
				break;
				case "4":
				return "FOUR";
				break;
				case "5":
				return "FIVE";
				break;
				case "6":
				return "SIX";
				break;
				case "7":
				return "SEVEN";
				break;
				case "8":
				return "EIGHT";
				break;
				case "9":
				return "NINE";
				break;
				default:
				return s;
			}
		}
		
		public static var _colorBtn:Array;
		private const _colorHotKeys:Array = ["Q", "W", "E", "R", "T", "Y"];
		
		public static var _sizeBtn:Array;
		private const _sizeHotKeys:Array = ["1","2","3","4","5","6"];
		
		private const _buttonWidth:int = 34;
		public static var _selectedCol:int;
		public static var _selectedSize:int;
		private var _canvas:FlxSprite;
		private var _moving:Boolean;
		private var _holdtime:Number;
		override public function create():void
		{
			_curvemode = false;
			_downOnCanvas = false;
			_lastx = FlxG.mouse.x;
			_lasty = FlxG.mouse.y;
			_holdtime = 0;
			
			/*_b1 = new FlxButton(0, 0, onClick1);
			_b1.loadGraphic((new FlxSprite()).createGraphic(34, 34, 0xff3a5c39), (new FlxSprite()).createGraphic(34, 34, 0xff729954));
			_b1.loadText(new FlxText(0, 0, FlxG.width, "1"));
			this.add(_b1);*/
			
//			onClick1();
			_colorBtn = new Array();
			_sizeBtn = new Array();
			
			var cursorSprite:FlxSprite = new FlxSprite(0, 0);
			cursorSprite.frameHeight = _buttonWidth;
			cursorSprite.frameWidth = _buttonWidth;
			cursorSprite.createGraphic(6 * _buttonWidth, _buttonWidth);
			cursorSprite.frameHeight = _buttonWidth;
			cursorSprite.frameWidth = _buttonWidth;
			
			for (var sizebtns:int = 0; sizebtns < 2; sizebtns++)
			{
				for (var i:int = 0; i < 6; i++)		
				{
					var handler:ClickHandler = new ClickHandler(i, sizebtns==0);
					var b:FlxButton = new FlxButton(sizebtns*(_buttonWidth+2), _buttonWidth*i, handler.onClick);
					var onSpr:FlxSprite = new FlxSprite(0, 0);
					onSpr.createGraphic(_buttonWidth, _buttonWidth, 0xff000000);
					onSpr._pixels.fillRect(new Rectangle(1, 1, _buttonWidth - 2, _buttonWidth - 2), 0xffffffff);
					onSpr.resetHelpers();
					var offSpr:FlxSprite = new FlxSprite(0, 0);
					offSpr.createGraphic(_buttonWidth, _buttonWidth, 0xffffffff);
					offSpr._pixels.fillRect(new Rectangle(1, 1, _buttonWidth - 2, _buttonWidth - 2), 0xff000000);
					offSpr.resetHelpers();
					
					var r:Number = 2 + (i * (_buttonWidth-4) / (2*5));
					if (sizebtns == 1)
					{
						for (var k:int = 1; k < _buttonWidth-2; k++)
						{
							for (var j:int = 1; j < _buttonWidth-2; j++)
							{
								var tx:int = k - (_buttonWidth-2) / 2;
								var ty:int = j - (_buttonWidth-2) / 2;
								offSpr._pixels.setPixel(k, j, tx*tx+ty*ty<r*r?0xffffffff:0xff000000);
								onSpr._pixels.setPixel(k, j, tx * tx + ty * ty < r * r?0xff000000:0xffffffff);
								cursorSprite._pixels.setPixel(i * _buttonWidth + k, j, tx * tx + ty * ty<r*r && tx*tx+ty*ty>(r-1)*(r-1) ?0xff000000:0x00ffffff);								
							}
						}
					}
					else
					{
						for (k = 2; k < _buttonWidth-2; k++)
						{
							for (j = 11; j < _buttonWidth-2; j++)
							{
								var randn:Boolean =  Math.random() < i / 5.0; 
								offSpr._pixels.setPixel(k, j,randn?0xffffffff:0xff000000);
								onSpr._pixels.setPixel(k, j, randn?0xff000000:0xffffffff);
							}
						}						
					}
					onSpr.resetHelpers();
					offSpr.resetHelpers();
					
					b.loadGraphic(onSpr, offSpr);
					
					var onText:FlxText = new FlxText(0, 0, _buttonWidth);
					onText.color = 0xff000000;				
					var offText:FlxText = new FlxText(0, 0, _buttonWidth);
					offText.color = 0xffffffff;
					if (sizebtns == 1)
					{
						onText.text = _sizeHotKeys[i];
						offText.text = _sizeHotKeys[i];
					}
					else
					{
						onText.text = _colorHotKeys[i];
						offText.text = _colorHotKeys[i];						
					}
					b.loadText(onText, offText);
					this.add(b);
					if (sizebtns == 1)
					{
						_sizeBtn.push(b);
					}
					else
					{
						_colorBtn.push(b);
					}
					
					
				}
			}
			cursorSprite.resetHelpers();
			for (i = 0; i < 6; i++)
			{
				cursorSprite.addAnimation(i.toString(), [i], 0, false);
			}
			/*
			FlxG.mouse.cursor = cursorSprite;
			FlxG.mouse.cursor.offset.x = _buttonWidth / 2;
			FlxG.mouse.cursor.offset.y = _buttonWidth / 2;
			FlxG.mouse.show();
			*/
			_selectedCol = 5;
			_selectedSize = 2;
			
			_sizeBtn[2].on = true;
			_colorBtn[5].on = true;
			
			_canvas = new FlxSprite(_buttonWidth*2+2,0);
			_canvas.createGraphic(FlxG.width-(_buttonWidth*2+2), FlxG.height, 0xffffffff, true);
			_canvas.x = _buttonWidth*2+2;
			this.add(_canvas);
			_moving = false;		
		}

		
		private const dither:Array = [
		[1, 9, 3, 11],
		[13, 5, 15, 7],
		[4, 12, 2, 10],
		[16, 8, 14, 6]					
		];	
		
		override public function update():void
		{			
			super.update();
			if (FlxG.mouse.justPressed())
			{
				_mx = FlxG.mouse.x - 2*_buttonWidth-2;
				_my = FlxG.mouse.y;
				if (FlxG.mouse.x > _buttonWidth * 2 + 2)
				{
					_downOnCanvas = true;
				}
				else
				{
					_downOnCanvas = false;
				}
			}
			
			if (FlxG.keys.justPressed("C"))
			{
				this._curvemode = !this._curvemode;
			}
		
			for (var i:int = 0; i < 6; i++)
			{
				if (FlxG.keys.justPressed(numToLetter(_colorHotKeys[i])))
				{
					var handler:ClickHandler = new ClickHandler(i,true);
					handler.onClick();
				}
				if (FlxG.keys.justPressed(numToLetter(_sizeHotKeys[i])))
				{
					handler = new ClickHandler(i,false);
					handler.onClick();
				}
			}
			
			_holdtime += FlxG.elapsed;
			var pulse:Boolean = false;
			if (_holdtime > 0.2)
			{
				pulse = true;
				_holdtime = 0;
			}
			
			if (FlxG.mouse.justPressed())
			{
				pulse = true;
				_holdtime = 0;
			}
			
			if (FlxG.mouse.x != _lastx || FlxG.mouse.y != _lasty)
			{
				pulse = true;
			}
								trace(_mx, my);

			if (FlxG.mouse.pressed() && pulse && _downOnCanvas)
			{
				var bmd:BitmapData = _canvas._pixels;
				var bmd2:BitmapData = new BitmapData(bmd.width, bmd.height, true);
				
				var radius:Number = 2 + (_selectedSize * (_buttonWidth - 4) / (2 * 5));
				
				
				if (_curvemode)
				{
					var tmx:int = FlxG.mouse.x-(2*_buttonWidth+2);				
					var tmy:int = FlxG.mouse.y;
					var contraction:Number = Math.sqrt((_mx - tmx) * (_mx - tmx) + (_my - tmy) * (_my - tmy));

					if (contraction != 0)
					{
						_mx = _mx + (tmx - _mx) * (Math.max(radius,3)/(2.0 * contraction));
						_my = _my + (tmy - _my) * (Math.max(radius,3)/(2.0 * contraction));
					}
				}
				else
				{
					_mx = FlxG.mouse.x-(2*_buttonWidth+2);				
					_my = FlxG.mouse.y;
				}
				
				bmd2.copyPixels(bmd, bmd.rect, new Point(0, 0));
				if (_selectedCol == 1)
				{
					var avg:Number=0.0;
					var count:Number = 0.0;
					
					var m1:int = Math.min(bmd.width, _mx + radius);
					for (i = Math.max(0,_mx-radius); i <  m1; i++ )
					{
						var m2:int = Math.min(bmd.height,_my+radius);
						for (j = Math.max(0,_my-radius); j < m2; j++ )
						{
							count++;
							avg+= bmd.getPixel(i, j)==0xffffff?0:1;						
						}
					}	
					trace(avg);
					avg /= count;
				}
				m1 = Math.min(bmd.width, _mx + radius);
				for (i = Math.max(0,_mx-radius); i < m1; i++ )
				{
					m2 =  Math.min(bmd.height, _my + radius);
					for (var j:int = Math.max(0,_my-radius); j < m2; j++ )
					{
						var tx:int = i - _mx;
						var ty:int = j - _my;
						if (tx * tx + ty * ty < radius * radius)
						{
							switch (_selectedCol)
							{
								case 0:
									bmd2.setPixel(i,j, 0xffffffff);								
								break;
								case 1:					
									bmd2.setPixel(i, j, (dither[i%4][j%4])/17.0>avg?0xffffffff:0xff0000000);							
								break;
								case 2:
									p11 = bmd.getPixel(i, j);
									p12 = bmd.getPixel(i+1, j);
									p21 = bmd.getPixel(i-1, j);
									p01 = bmd.getPixel(i, j+1);
									p10 = bmd.getPixel(i, j-1);									
									bmd2.setPixel(i, j,  p11 ^ p12 ^ p21 ^ p01 ^ p10);								
								break;
								case 3:
									p11 = bmd.getPixel(i, j);
									p12 = bmd.getPixel(i+1, j);
									p21 = bmd.getPixel(i-1, j);
									p01 = bmd.getPixel(i, j+1);
									p10 = bmd.getPixel(i, j - 1);		
									
									bmd2.setPixel(i, j,  (p12 & p21) | (p01 & p10));									
								break;
								case 4:
									var p11:uint = bmd.getPixel(i, j);
									var p12:uint = bmd.getPixel(i+1, j+1);
									var p21:uint = bmd.getPixel(i+1, j-1);
									var p01:uint = bmd.getPixel(i-1, j-1);
									var p10:uint = bmd.getPixel(i-1, j + 1);
									
									bmd2.setPixel(i, j, p11 & p12 & p21 & p01 & p10);									
								break;
								case 5:
									bmd2.setPixel(i,j, 0xff000000);								
								break;
							}
						}
					}
					_canvas._pixels = bmd2;
					_canvas.resetHelpers();

				}
				
			}

			/*if (_moving)
			{
				switch(_selectedSize)
				{
					case 1:
							
						for (i = 1; i < bmd.width-1; i++)
						{
							for (j = 1; j < bmd.height-1; j++)
							{										
								p11 = bmd.getPixel(i, j);
								p12 = bmd.getPixel(i, j+1);
								p21 = bmd.getPixel(i+1, j);
								p01 = bmd.getPixel(i-1, j);
								p10 = bmd.getPixel(i, j- 1);
								
								bmd2.setPixel(i, j, p11 & p12 & p21 & p01 & p10);
							}
						}
						_canvas._pixels = bmd2;
						break;
					case 2:
							
						for (var i:int = 1; i < bmd.width-1; i++)
						{
							for (var j:int = 1; j < bmd.height-1; j++)
							{										
								var p11:uint = bmd.getPixel(i, j);
								var p12:uint = bmd.getPixel(i+1, j+1);
								var p21:uint = bmd.getPixel(i+1, j-1);
								var p01:uint = bmd.getPixel(i-1, j-1);
								var p10:uint = bmd.getPixel(i-1, j + 1);
								
								bmd2.setPixel(i, j, p11 | p12 | p21 | p01 | p10);
							}
						}
						_canvas._pixels = bmd2;
						break;
					case 3:
					//random copying
							
						//var n:int = Math.random() * 10;
						
						//for (i = 1; i < n;i++)
						{
							var w:int = Math.random()*bmd.width;
							var h:int = Math.random()*bmd.height;
							var x:int = Math.random()*(bmd.width-w);
							var y:int = Math.random()*(bmd.height-h);
							var x2:int = Math.random()*(bmd.width-w);
							var y2:int = Math.random() * (bmd.height - h);
							bmd2 = bmd;
							bmd2.copyPixels(bmd, new Rectangle(x, y, w, h), new Point(x2, y2));
						}
						_canvas.pixels = bmd2;
						break;
					case 4:
							
						for (j = 1; j < bmd.height-1; j++)
						{
							for (i = bmd.width-2; i >0 ; i--)
							{												
								p11 = bmd.getPixel(i, j);
								var p22:int = bmd.getPixel(i+1, j+1);
								var p00:int = bmd.getPixel(i-1, j-1);
								var p20:int = bmd.getPixel(i+1, j-1);
								var p02:int = bmd.getPixel(i-1, j + 1);
								bmd2.setPixel(i, j, p22 ^ p20 ^ p00 ^ p02 ^ p11);
							}
						}
						_canvas.pixels = bmd2;
						break;
					case 5:
							
						for (i = 1; i < bmd.width-1; i++)
						{
							for (j = 1; j < bmd.height-1; j++)
							{												
								p11 = bmd.getPixel(i, j);
								p12 = bmd.getPixel(i, j+1);
								p21 = bmd.getPixel(i+1, j);
								p01 = bmd.getPixel(i-1, j);
								p10 = bmd.getPixel(i, j - 1);
								
								bmd2.setPixel(i, j, p11 ^ p12 ^ p21 );
							}
						}
						_canvas.pixels = bmd2;
						break;
					case 6:
							
						for (i = 1; i < bmd.width-1; i++)
						{
							for (j = 1; j < bmd.height-1; j++)
							{												
								p11 = bmd.getPixel(i, j);
								p12 = bmd.getPixel(i, j+1);
								p21 = bmd.getPixel(i+1, j);
								p01 = bmd.getPixel(i-1, j);
								p10 = bmd.getPixel(i, j - 1);
								
								bmd2.setPixel(i, j, (p12+p21)/2);
							}
						}
						_canvas.pixels = bmd2;
						break;
					case 7:
							
						for (j = 1; j < bmd.height-1; j++)
						{
							for (i = bmd.width-2; i >0 ; i--)
							{												
								p11 = bmd.getPixel(i, j);
								p12 = bmd.getPixel(i, j+1);
								p21 = bmd.getPixel(i+1, j);
								p01 = bmd.getPixel(i-1, j);
								p10 = bmd.getPixel(i, j - 1);
								bmd2.setPixel(i, j, (p21 & 0x0000ff) + (p10 & 0x00ff00) + (p12 & 0xff0000) );
							}
						}
						_canvas.pixels = bmd2;
						break;
				}
			}
			*/
			_lastx = FlxG.mouse.x;
			_lasty = FlxG.mouse.y;
			
		}
		
	}
}

	import org.flixel.*;

class ClickHandler {	
	private var _n:int;
	private var _col:Boolean;
	function ClickHandler(n:int,col:Boolean):void
	{
		_n = n;
		_col = col;
	}
	public function onClick():void
	{
		if (_col)
		{
			for (var i:int = 0; i < com.adamatomic.Mode.MenuState._colorBtn.length; i++)
			{
				var btn:FlxButton = com.adamatomic.Mode.MenuState._colorBtn[i];
				btn.on = i == _n;
			}
			com.adamatomic.Mode.MenuState._selectedCol = _n;
		}
		else 
		{
			for (i = 0; i < com.adamatomic.Mode.MenuState._sizeBtn.length; i++)
			{
				btn = com.adamatomic.Mode.MenuState._sizeBtn[i];
				btn.on = i == _n;
			}
			//FlxG.mouse.cursor.play(_n.toString());
			com.adamatomic.Mode.MenuState._selectedSize = _n;
		}
	}
}
